#include <stdio.h>
#include <stdlib.h>
#include "types.h"
#include "defines.h"

/* defines */

/* None */

/* external variables */

extern U8 PointVisable[MAP_WIDTH][MAP_HEIGHT];

/* global variables */

STATIC_OBJECT_TYPE    StaticObjectList[MAXSTATS];
STATIC_OBJECT_TYPE    *LastStaticObj = NULL;

/* local variables */

/* None */

/* local prototypes */

static void SpawnStatic(S32 TileX, S32 TileY);

/*
===============================================================================
 \brief spawns all static objects into map
 \param None
 \return None
===============================================================================
*/
void InitStaticObjects(void)
{
    /* init static object pointer */ 
    LastStaticObj = StaticObjectList;
    /* spawn five static SCP at different locations */
    SpawnStatic(4, 4);
    SpawnStatic(22, 10);
    SpawnStatic(4, 27);
    SpawnStatic(27, 19);
    SpawnStatic(17, 27);      
}

/*
===============================================================================
 \brief Displays a BMP image to screen
 \param TileX: X location of static object on map
 \param TileY: Y location of static object on map
 \return None
===============================================================================
*/
static void SpawnStatic(S32 TileX, S32 TileY)
{
    LastStaticObj->TileX = TileX;
    LastStaticObj->TileY = TileY;
    LastStaticObj->VisableSpot = &PointVisable[TileY][TileX];
    LastStaticObj->ShapeNum = SCPPic;
    LastStaticObj++;             
} 
