#ifndef DEFINES_H
#define DEFINES_H

#define ANGLES              360
#define ANGLEQUAD           (ANGLES/4)
#define BIN16               (1l<<16)
#define FINEANGLES          3600
#define MAP_WIDTH           32
#define MAP_HEIGHT          32
#define SCREEN_WIDTH        640
#define SCREEN_HEIGHT       400
#define ORIG_SCREEN_WIDTH   320
#define ORIG_SCREEN_HEIGHT  200
#define ORIG_SCREEN_CENTRE  100
#define GRID_SIZE           65536
#define MAP_TO_GRID_SHIFT   16l
#define MINDIST             0x5800l    /* in global coordinates */
#define FOCAL_LENGTH        0x5700l
#define FACE_DISTANCE       (FOCAL_LENGTH + MINDIST)
#define PROJECTION_RATIO    (((ORIG_SCREEN_WIDTH / 2) * FACE_DISTANCE) / (GRID_SIZE /2)) 
#define PROJECTION_RATIO_SCALED    (GRID_SIZE * PROJECTION_RATIO)
#define MAP_WIDTH_SHIFT     5
#define CHAR_HEIGHT         8
#define CHAR_WIDTH          8
#define SCALING             (SCREEN_WIDTH / ORIG_SCREEN_WIDTH)
#define STATUSLINES         40
#define MAXSTATS            5
#define MAX_VISABLE         5 

/* 
================================================================
=
= Function: FixedMul
=
= Description:
=
= multiply two S32 numbers (and round result up)
= then store result back into a S32
=
================================================================
*/
static inline S32 FixedMul(S32 a, S32 b)
{
    return (S32)(((long long)a * b + 0x8000) >> 16);
}

#endif
