#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>
#include "types.h"

/* defines */

/* None */

/* external variables */

/* None */

/* global variables */

/* None */

/* local variables */

static SDL_Event event = {0};

/* local prototypes */

/* None */

/*
===============================================================================
 \brief Get user input
 \param Pointer to struct that will hold the users input
 \return None
===============================================================================
*/
void GetUserInput(INPUT_TYPE *Controls)
{
    U8 *KeyPressed;
    SDL_Event event = {0};

    KeyPressed = SDL_GetKeyState(NULL);

    if(KeyPressed[SDLK_RIGHT] != 0)
    {
        Controls->Right = 1;
    }

    if(KeyPressed[SDLK_LEFT] != 0)
    {
        Controls->Left = 1;
    }

    if(KeyPressed[SDLK_UP] != 0)
    {
        Controls->Forward = 1;
    }

    if(KeyPressed[SDLK_DOWN] != 0)
    {
        Controls->Back = 1;
    }
    
    if(KeyPressed[SDLK_1] != 0)
    {
        Controls->One = 1;
    }
    
    if(KeyPressed[SDLK_2] != 0)
    {
        Controls->Two = 1;
    }
    
    if(KeyPressed[SDLK_3] != 0)
    {
        Controls->Three = 1;
    }
    
    if(KeyPressed[SDLK_4] != 0)
    {
        Controls->Four = 1;
    }

    SDL_PollEvent(&event);

    if(event.type == SDL_QUIT)
    {
        Controls->Exit = 1;
    }
}

/*
===============================================================================
 \brief Delay for seconds passed or returns if user wants to exit game
 \param seconds to delay for
 \return None
===============================================================================
*/
U8 DelaySecondsWithExit(U32 Seconds)
{
    INPUT_TYPE UserControls;
    memset(&UserControls,0,sizeof(UserControls));
    S32 i;
    U8 Exit = 0;

    for(i = 0; i < (Seconds * 10) ; i++)
    {
        SDL_Delay(100);
        GetUserInput(&UserControls);
        if(UserControls.Exit == 1)
        {
            /* user wants to exit program */
            Exit = 1;
            break;                     
        }      
    }
    
    return Exit;
}
