#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>
#include "types.h"
#include "defines.h"

/* defines */

#define SECOND    1000

/* external variables */

GAMESTATE_TYPE GameState;

/* global variables */

/* None */

/* local variables */

static U32 CurrentTime;

/* local prototypes */

/* None */

/*
===============================================================================
 \brief Sets current time
 \param None
 \return None
===============================================================================
*/
void SetGameTime(void)
{
    CurrentTime = SDL_GetTicks();        
}

/*
===============================================================================
 \brief Update game count down timer
 \param None
 \return None
===============================================================================
*/
void UpdateGameTime(void)
{    
    U32 DeltaTime;
    
    DeltaTime = SDL_GetTicks() - CurrentTime;
    
    /* Convert time from ms into seconds */    
    GameState.TimeCount -= DeltaTime / SECOND;
    
    /* Handle roll over */
    if(GameState.TimeCount < 0)
    {
         GameState.TimeCount = 0;                      
    }
    
    /* update current time if a minimum of one second has passed */
    if(DeltaTime > SECOND)
    {
        CurrentTime += DeltaTime;
    }
}

/*
===============================================================================
 \brief delay for a period of time 
 \param Time to delay for
 \return None
===============================================================================
*/
void DelayMs(U32 DelayTimeMs)
{
    SDL_Delay(DelayTimeMs);     
}
