#include <stdio.h>
#include <stdlib.h>
#include "types.h"
#include "defines.h"
#include "video_low.h"

/* defines */

#define    BOARDER_WIDTH    16

/* external variables */

/* None */

/* global variables */

/* None */

/* local variables */

/* None */

/* local prototypes */
static void DrawOutline(U32 X, U32 Y, U32 Width, U32 Height, COLOUR_TYPE Colour1
                         ,COLOUR_TYPE Colour2, U8 Scaling);

/*
===============================================================================
 \brief Draw a message within a window onto the centre of screen
 \param string: message to print to the screen
 \return None
===============================================================================
*/
void Message(const char *String)
{
    COLOUR_TYPE WindowColour = {255, 255, 255}; 
    COLOUR_TYPE OutLineColour = {0,0,255};
    COLOUR_TYPE TextColour = {0,0,0};
    
    U32 Length = (U32)strlen(String) * CHAR_WIDTH;
    U32 XStartPoint = (ORIG_SCREEN_WIDTH / 2) - (Length / (2 * SCALING));
     
    DrawRec(XStartPoint - BOARDER_WIDTH, ((ORIG_SCREEN_HEIGHT / 2) - CHAR_HEIGHT), (Length / SCALING) + (BOARDER_WIDTH * 2), (CHAR_HEIGHT * 2), WindowColour, SCALING);
    DrawOutline(XStartPoint - BOARDER_WIDTH, ((ORIG_SCREEN_HEIGHT / 2) - CHAR_HEIGHT), (Length / SCALING) + (BOARDER_WIDTH * 2), (CHAR_HEIGHT * 2), 
                               OutLineColour, OutLineColour, SCALING);
    
    MyPrint(String, XStartPoint , (ORIG_SCREEN_HEIGHT / 2), SCALING);
}

/*
===============================================================================
 \brief Draw a small frame (outline) around a given window
 \param X: start point of outline in the x plane
 \param Y: start point of outline in the y plane
 \param Width: width of outline
 \param Height: height of outline
 \param Colour1: colour of upper left outline
 \param Colour2: colour of lower right outline
 \return None
===============================================================================
*/
static void DrawOutline(U32 X, U32 Y, U32 Width, U32 Height, COLOUR_TYPE Colour1
                         ,COLOUR_TYPE Colour2, U8 Scaling)
{
    /* upper left */
    DrawHorzLine(X, Y, Width, Colour1, Scaling);
    DrawVertLine(X, Y, Height, Colour1, Scaling);
    
    /* lower right */
    DrawHorzLine(X, (Y + Height), Width, Colour2, Scaling);
    DrawVertLine((X + Width), Y , Height, Colour2, Scaling);               
}


